﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Serialization;

namespace MapExtension
{
    [Serializable()]
    [XmlRoot("map")]
    public class MapFile
    {
        /* Attributes */
        [XmlAttribute("version")]
        public string version { get; set; }
        [XmlAttribute("tiledversion")]
        public string tiledVersion { get; set; }
        [XmlAttribute("orientation")]
        public string orientation { get; set; }
        [XmlAttribute("renderorder")]
        public string renderOrder { get; set; }
        [XmlAttribute("compressionlevel")]
        public int compressionLevel { get; set; }
        [XmlAttribute("width")]
        public int width { get; set; }
        [XmlAttribute("height")]
        public int height { get; set; }
        [XmlAttribute("tilewidth")]
        public int tileWidth { get; set; }
        [XmlAttribute("tileheight")]
        public int tileHeight { get; set; }
        [XmlAttribute("infinite")]
        public bool infinite { get; set; }
        [XmlAttribute("nextlayerid")]
        public int nextLayerId { get; set; }
        [XmlAttribute("nextobjectid")]
        public int nextObjectId { get; set; }

        /* Children */
        [XmlElement("tileset")]
        public TileSet tileSet;
        [XmlElement("layer", typeof(Layer))]
        public Layer[] layers { get; set; }
    }

    [Serializable()]
    public class TileSet
    {
        /* Attributes */
        [XmlAttribute("firstgid")]
        public int firstGid { get; set; }
        [XmlAttribute("source")]
        public string source { get; set; }

        /* Contetnt */
    }

    [Serializable()]
    public class Layer
    {
        /* Attributes */
        [XmlAttribute("id")]
        public int id { get; set; }
        [XmlAttribute("name")]
        public string name { get; set; }
        [XmlAttribute("width")]
        public int width { get; set; }
        [XmlAttribute("height")]
        public int height { get; set; }

        /* Content */
        [XmlElement("data")]
        public string data { get; set; }
    }
}
