﻿using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MapExtension
{
    [ContentTypeWriter]
    public class TiledMapWriter : ContentTypeWriter<MapFile>
    {
        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            return "ProjektStatki.TiledMapReader, ProjektStatki";
        }

        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            return typeof(TiledMapData).AssemblyQualifiedName;
        }

        protected override void Write(ContentWriter output, MapFile value)
        {
            output.Write(value.width);
            output.Write(value.height);
            output.Write(value.nextLayerId - 1);

            foreach (Layer layer in value.layers)
            {
                output.Write(layer.data);
            }
        }
    }
}
