﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace ProjektStatki
{
    public class CannonBall : GameObject
    {
        private Character owner;
        private Vector2 direction;
        private double range;
        private double speed = 450;
        private int damage;

        public CannonBall(int x, int y, int range, int damage, Vector2 direction, Character owner)
        {
            this.bitmap = Game1.canonBallImage;
            this.hitbox = new Rectangle(x, y, bitmap.Width, bitmap.Height);
            this.direction = direction;
            this.range = range;
            this.damage = damage;
            this.owner = owner;

            // Subscribe self to game objects
            Game1.gObjects.Add(this);
        }

        public override void Update()
        {
            List<Character> ships = Game1.ships;

            // Move the bullet
            this.hitbox.Set(this.x + (int)Math.Round(this.direction.X * Game1.STEP * this.speed),
                            this.y + (int)Math.Round(this.direction.Y * Game1.STEP * this.speed));

            // Update range
            this.range -= Game1.STEP * this.speed;

            // destroy bullet after moving it's range
            if (this.range <= 0) { Game1.DeleteObject(this); }

            // Check ships collision
            foreach (Character ship in ships)
            {
                if (this.hitbox.Overlaps(ship.Hitbox) && this.owner.GetType() != ship.GetType())
                {
                    ship.Health -= this.damage;
                    //if (ship is Player) MakeSound();
                    Game1.DeleteObject(this);
                }
            }
        }

        public override void Draw(SpriteBatch spriteBatch, Camera C)
        {
            spriteBatch.Begin();
            spriteBatch.Draw(this.bitmap, new Vector2(this.x - C.xView, this.y - C.yView));
            spriteBatch.End();
        }
    }
}
