﻿using MapExtension;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace ProjektStatki
{
    /* Map which takes "Tiled Map Editor" file as initialization */
    public class Map : GameObject
    {
        public int cols;
        public int rows;
        private List<Chunk> tiles;
        public List<Chunk> Tiles { get => tiles; }

        public Map(Texture2D mapImage, TiledMapData mapData)
        {
            this.hitbox = new Rectangle(0, 0, mapImage.Width, mapImage.Height);
            Debug.WriteLine(hitbox.width);
            Debug.WriteLine(hitbox.height);
            this.bitmap = mapImage;
            this.cols = mapData.cols;
            this.rows = mapData.rows;
            // Get information about each tile in 2nd layer (collidable chunks)
            List <long> tilesData = mapData.layersData[1].Split(',').Select(Int64.Parse).ToList();
            tiles = new List<Chunk>( new Chunk[rows * cols] );

            // Initialize tiles list
            for (int i = 0; i < cols * rows; i++)
            {
                int x = i % cols;
                int y = i / cols;
                tiles[i] = new Chunk(x, y, (int)tilesData[i]);      
            }

            // Subscribe self to game objects
            Game1.gObjects.Add(this);
        }

        public override void Draw(SpriteBatch spriteBatch, Camera C)
        {
            spriteBatch.Begin();
            spriteBatch.Draw(this.bitmap, new Vector2(0, 0), null, Color.White, 0, new Vector2(C.xView, C.yView), 1, SpriteEffects.None, 0);
            spriteBatch.End();
        }

        public override void Update()
        {

        }

        public class Chunk : GameObject
        {
            public int x;
            public int y;
            public int row;
            public int col;
            private int id;
            public bool collidable;

            public Chunk(int x, int y, int id)
            {
                this.col = x;
                this.row = y;
                this.x = x*64;
                this.y = y*64;
                this.id = id;

                if (id > 0) {
                    this.collidable = true;
                    this.bitmap = Game1.tileImages[id];
                    this.bitmapData = new Color[this.bitmap.Width * this.bitmap.Height];
                    this.bitmap.GetData<Color>(this.bitmapData);
                } else {
                    this.collidable = false;
                }
         
                this.hitbox = new Rectangle(x,y,64,64);
                this.rotation = 0;
            }

            public override void Draw(SpriteBatch spriteBatch, Camera C)
            {
                return;
            }

            public override void Update()
            {
                return;
            }
        }
    }
}
