﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjektStatki
{
    public class Rectangle
    {
        private int _left;
        private int _right;
        private int _top;
        private int _bottom;
        private int _width;
        private int _height;

        public int left { get => _left; }
        public int right { get => _right; }
        public int top { get => _top; }
        public int bottom { get => _bottom; }
        public int width { get => _width; }
        public int height { get => _height; }

        public Rectangle(int left, int top, int width, int height)
        {
            this._width = width;
            this._height = height;

            this._left = left;
            this._right = left + width;

            this._top = top;
            this._bottom = top + height;
        }

        public void Set(int left, int top, /*optional*/ int width = 0, /*optional*/ int height = 0)
        {
            if (width > 0) { this._width = width; }
            if (height > 0) { this._height = height; }

            this._left = left;
            this._top = top;
            this._right = (this._left + this._width);
            this._bottom = (this._top + this._height);
        }

        public bool Overlaps(Rectangle other)
        {
            return (other.right >= this._left &&
                    other.left <= this._right &&
                    other.bottom >= this._top &&
                    other.top <= this._bottom);
        }

        public bool Within(Rectangle other)
        {
            return (other.left >= this.left &&
                    other.right <= this.right &&
                    other.top >= this.top &&
                    other.bottom <= this.bottom);
        }
    }
}
