﻿using Microsoft.Xna.Framework.Content;
using MapExtension;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjektStatki
{
    public class TiledMapReader : ContentTypeReader<TiledMapData>
    {
        protected override TiledMapData Read(ContentReader input, TiledMapData existingInstance)
        {
            int cols = input.ReadInt32();
            int rows = input.ReadInt32();
            int layersCount = input.ReadInt32();
            List<string> layersData = new List<string>();

            for (int i=0; i<layersCount; i++)
            {
                string data = input.ReadString();
                layersData.Add(data);
            }

            return new TiledMapData(cols, rows, layersCount, layersData);
        }
    }
}
